/* ============================================================================================== *
 *                                                                                                *
 *                                       Xi Blockchain                                            *
 *                                                                                                *
 * ---------------------------------------------------------------------------------------------- *
 * This file is part of the Galaxia Project - Xi Blockchain                                       *
 * ---------------------------------------------------------------------------------------------- *
 *                                                                                                *
 * Copyright 2018-2019 Galaxia Project Developers                                                 *
 *                                                                                                *
 * This program is free software: you can redistribute it and/or modify it under the terms of the *
 * GNU General Public License as published by the Free Software Foundation, either version 3 of   *
 * the License, or (at your option) any later version.                                            *
 *                                                                                                *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;      *
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
 * See the GNU General Public License for more details.                                           *
 *                                                                                                *
 * You should have received a copy of the GNU General Public License along with this program.     *
 * If not, see <https://www.gnu.org/licenses/>.                                                   *
 *                                                                                                *
 * ============================================================================================== */

#include <gmock/gmock.h>

#include <Xi/Rct/Constants.h>
#include <Xi/Rct/Algorithm/KeyHashing.h>

#define XI_TESTSUITE T_Xi_Rct_KeyHashing

TEST(XI_TESTSUITE, FastHash) {
  using namespace ::testing;
  using namespace ::Xi;
  using namespace ::Xi::Rct;

  std::vector<std::pair<KeyVector, Rct::Key>> Oracle{{
      {{{{0x7d, 0x2a, 0x46, 0xb0, 0x37, 0x1d, 0xbf, 0xd,  0x26, 0xa2, 0xdd, 0xe4, 0x6f, 0xa2, 0x78, 0x36,
          0x7b, 0xc2, 0xc4, 0x98, 0xb7, 0x3c, 0x8d, 0x1c, 0xdf, 0xf7, 0x4c, 0x94, 0x38, 0xe3, 0x7d, 0xf}}},
       {{0x48, 0x8e, 0x8a, 0x59, 0x70, 0xd2, 0xe6, 0x98, 0x28, 0x5,  0xfd, 0x5,  0xdc, 0x7a, 0x4b, 0x8f,
         0x6b, 0x43, 0xeb, 0x0,  0xd0, 0x1c, 0xf2, 0x4,  0x1,  0xd7, 0xf2, 0x20, 0x22, 0x4b, 0x25, 0xf6}}},

      {{{{0x8f, 0x11, 0xae, 0x5e, 0xe, 0x89, 0x68, 0xd2, 0x9d, 0x86, 0x95, 0xc0, 0x23, 0x5a, 0xe8, 0x5b,
          0x18, 0xaa, 0xdd, 0xae, 0x2, 0x64, 0xbb, 0xc9, 0xa9, 0xe8, 0x2b, 0xfb, 0x45, 0x24, 0xbf, 0x47}}},
       {{0x66, 0x54, 0xcd, 0x77, 0x72, 0x70, 0x4f, 0x85, 0x1c, 0x1f, 0xd,  0xfc, 0xd6, 0x7b, 0x4c, 0x3c,
         0x6,  0xc0, 0x91, 0x3d, 0xdd, 0x99, 0xe5, 0xc7, 0x4a, 0xbd, 0x5b, 0x22, 0x5a, 0x56, 0xee, 0x3b}}},

      {{{{0x97, 0x83, 0x64, 0xaa, 0x60, 0x81, 0x9e, 0xe5, 0x7c, 0xb4, 0xe9, 0xe9, 0x32, 0x73, 0xaa, 0xd0,
          0x8b, 0x9a, 0x47, 0x2,  0x92, 0x30, 0x1e, 0xbf, 0x40, 0x3b, 0xb0, 0x55, 0x16, 0x5f, 0x14, 0xfc}}},
       {{0xe0, 0x38, 0xe5, 0x4c, 0x77, 0xa8, 0xbd, 0xae, 0x31, 0xf5, 0x9c, 0xf2, 0x28, 0x82, 0xa7, 0x0,
         0x78, 0x9f, 0xc6, 0x97, 0xf8, 0x51, 0xac, 0xf7, 0x9,  0x50, 0x7,  0xc0, 0xa9, 0xec, 0xc1, 0x94}}},

      {{{{0xe0, 0xe8, 0x88, 0xbb, 0x25, 0x1c, 0x65, 0x3a, 0xc9, 0xdd, 0x31, 0x7b, 0xcb, 0x7e, 0x44, 0xe5,
          0xe8, 0x88, 0x6d, 0xe0, 0xf8, 0x1b, 0x23, 0x24, 0x50, 0xd9, 0x7a, 0x2d, 0xcf, 0xdc, 0x5c, 0xcd}}},
       {{0xfc, 0xfd, 0x90, 0x61, 0xfb, 0xd6, 0x9c, 0x79, 0xd3, 0x2a, 0x98, 0x4d, 0xd1, 0xa0, 0x3b, 0x33,
         0x91, 0x92, 0xb6, 0xfd, 0x2d, 0xb6, 0x74, 0x1,  0x4,  0x6c, 0xf1, 0xa6, 0x9a, 0xaf, 0x91, 0x14}}},

      {{{{0xee, 0xde, 0xaa, 0x8e, 0x44, 0xb2, 0x81, 0x57, 0x54, 0x82, 0xe7, 0x80, 0xc4, 0x84, 0xf2, 0x9d,
          0x13, 0xa6, 0x16, 0x6b, 0x85, 0xbe, 0xce, 0x42, 0x5d, 0xa6, 0xff, 0x95, 0x91, 0x6c, 0x86, 0x94}}},
       {{0x13, 0xdc, 0x8e, 0x4f, 0x7c, 0xf5, 0xf5, 0xa6, 0x10, 0x61, 0xbd, 0xb9, 0x4c, 0xa4, 0xa0, 0x82,
         0x62, 0x66, 0x4,  0x20, 0x1f, 0x2a, 0xa,  0xde, 0x87, 0x2b, 0x76, 0xe,  0xf7, 0xbe, 0xee, 0x73}}},

      {{{{0x1c, 0x33, 0x3e, 0x30, 0xff, 0x46, 0x61, 0x59, 0x52, 0xc2, 0xef, 0xd5, 0xbd, 0x1d, 0xeb, 0xc0,
          0xa,  0xd0, 0x34, 0x5d, 0x98, 0x4f, 0x2a, 0x9b, 0x55, 0x49, 0x84, 0x49, 0xa7, 0xfb, 0x39, 0xb7}}},
       {{0x7f, 0x8a, 0x70, 0xa0, 0x6e, 0xa8, 0x33, 0x28, 0xd6, 0xf5, 0x1b, 0x54, 0x4e, 0x5b, 0xe1, 0x44,
         0xfa, 0x88, 0xf6, 0x78, 0xc6, 0xe1, 0x7a, 0xb5, 0x24, 0x82, 0xa4, 0xf7, 0x5,  0x8f, 0x31, 0xb6}}},

      {{{{0xb8, 0xcc, 0xd8, 0x2b, 0x3e, 0xb2, 0x61, 0x6b, 0xe4, 0x42, 0x2,  0xb9, 0xec, 0x50, 0xae, 0x47,
          0xcc, 0xcd, 0x76, 0xff, 0xdb, 0xf7, 0xc4, 0x35, 0x90, 0x2f, 0x99, 0xb9, 0xb8, 0xba, 0x3a, 0xe5}}},
       {{0x7c, 0x3d, 0x93, 0x75, 0x75, 0x62, 0x11, 0x95, 0x91, 0xe6, 0xd1, 0xa,  0x13, 0xbc, 0x17, 0xf,
         0x10, 0xc5, 0x4c, 0x65, 0xac, 0x2a, 0xbd, 0x93, 0x42, 0x9,  0x51, 0xcd, 0xf3, 0x6,  0xa7, 0x4c}}},

      {{{{0x78, 0xef, 0x78, 0x88, 0x29, 0xf0, 0xab, 0xd,  0x37, 0x10, 0x9f, 0x7c, 0x56, 0x46, 0x49, 0xb6,
          0x3f, 0xdb, 0xed, 0x9e, 0x8d, 0x36, 0x37, 0xeb, 0xdc, 0x31, 0xd1, 0xe6, 0x97, 0x44, 0x23, 0xe2}}},
       {{0x5,  0xaa, 0x20, 0x7,  0xa9, 0x72, 0x8f, 0x77, 0x1b, 0xee, 0xd7, 0x22, 0xd4, 0x85, 0x23, 0x57,
         0x9e, 0xb2, 0x9c, 0x93, 0x6c, 0xfb, 0x1f, 0xc2, 0x7,  0xc6, 0x8f, 0xc3, 0x0,  0xe0, 0x27, 0x86}}},

      {{{{0x4b, 0xc6, 0x46, 0x26, 0x2f, 0x7d, 0x53, 0xc,  0x7d, 0x95, 0x90, 0xff, 0xf8, 0x57, 0xd7, 0x7c,
          0xfd, 0x7,  0x52, 0xed, 0xb3, 0xd8, 0x89, 0x6a, 0xb2, 0x70, 0x7,  0xcb, 0x4d, 0x37, 0x44, 0xc1}}},
       {{0xf9, 0x69, 0xe7, 0x67, 0x60, 0xb8, 0x18, 0x46, 0xdd, 0x20, 0x80, 0x71, 0x63, 0x12, 0x6a, 0x2c,
         0xd9, 0xed, 0x41, 0xca, 0xda, 0xb3, 0x0,  0x4d, 0x6c, 0x63, 0xcc, 0x98, 0x8d, 0xcc, 0xd6, 0x35}}},
  }};

  for (const auto& oracle : Oracle) {
    const auto& input = oracle.first;
    const auto& expected = oracle.second;
    auto returnVariant = key_fast_hash(input.front());
    Rct::Key inplaceVariant;
    key_fast_hash_inplace(input.front(), inplaceVariant);
    EXPECT_EQ(returnVariant, expected);
    EXPECT_EQ(inplaceVariant, expected);
  }
}

TEST(XI_TESTSUITE, FastHashToScalar) {
  using namespace ::testing;
  using namespace ::Xi;
  using namespace ::Xi::Rct;

  std::vector<std::pair<KeyVector, Rct::Key>> Oracle{{
      {{{{0x20, 0xe,  0x2b, 0xbe, 0xf2, 0xb,  0x86, 0xf7, 0xbd, 0x69, 0x58, 0x51, 0x10, 0x7a, 0x28, 0x1c,
          0x89, 0x96, 0xf7, 0xd1, 0x3a, 0xd3, 0x68, 0x74, 0x1f, 0x52, 0x6a, 0x8f, 0xf9, 0x9d, 0xf1, 0x33}}},
       {{0xaa, 0x77, 0x76, 0xa9, 0x58, 0x92, 0xba, 0x1e, 0x6f, 0xae, 0x9e, 0x7c, 0x1f, 0xbb, 0xf9, 0xc2,
         0x6,  0xf7, 0x93, 0x21, 0xe6, 0xe0, 0xd1, 0xa4, 0x22, 0x34, 0x52, 0xa5, 0x22, 0xcf, 0xc9, 0xc}}},

      {{{{0x5a, 0x7c, 0x54, 0x8f, 0xb2, 0x88, 0x85, 0x84, 0xe4, 0x92, 0x3b, 0x65, 0xbf, 0xfd, 0xed, 0x31,
          0xdf, 0x1c, 0xbf, 0x75, 0x45, 0xa,  0x9b, 0x81, 0x1e, 0x73, 0x6,  0xb9, 0xe8, 0xdf, 0xbe, 0xcf}}},
       {{0x93, 0x11, 0xe1, 0xf6, 0x39, 0x86, 0x3b, 0xf,  0x73, 0xab, 0xe5, 0x1c, 0xd6, 0xce, 0x64, 0x65,
         0xe5, 0xe5, 0xb,  0x63, 0x74, 0x77, 0x52, 0xa8, 0x12, 0xf0, 0x2a, 0x3e, 0x56, 0x48, 0x77, 0x4}}},

      {{{{0xaf, 0x5f, 0x7e, 0x4,  0x95, 0x15, 0x1,  0xec, 0x9,  0x10, 0x99, 0x1a, 0x24, 0x32, 0x20, 0x74,
          0x8b, 0x90, 0x8,  0x3f, 0xb2, 0x41, 0x74, 0xc6, 0xb0, 0x3,  0xd9, 0xee, 0xf1, 0x9d, 0x81, 0x48}}},
       {{0xdc, 0x14, 0x92, 0x43, 0x23, 0x6e, 0xf2, 0x9a, 0x14, 0x69, 0x3a, 0x70, 0xdc, 0x16, 0x8,  0x9a,
         0xc4, 0x9c, 0x8a, 0x7e, 0x2f, 0xac, 0x61, 0x69, 0x14, 0xb9, 0x63, 0xdf, 0x17, 0x3c, 0xce, 0x8}}},

      {{{{0x2d, 0xc8, 0x2e, 0xfd, 0xa7, 0x9d, 0xc1, 0x51, 0xdc, 0x55, 0x6,  0xd3, 0x8,  0x1f, 0x16, 0xbc,
          0x49, 0x37, 0xe6, 0x90, 0xd6, 0x25, 0x6f, 0x4c, 0x26, 0xc0, 0x24, 0x86, 0x97, 0x5a, 0x59, 0x3c}}},
       {{0xd2, 0x4e, 0x98, 0x6a, 0xb2, 0x62, 0x3e, 0x7c, 0x1e, 0x15, 0xeb, 0x22, 0x98, 0x9f, 0x7a, 0xdc,
         0xea, 0x3a, 0xa,  0x8b, 0xbc, 0xb6, 0xfd, 0xd6, 0x22, 0x28, 0x7d, 0xe0, 0x1d, 0x6f, 0x62, 0xe}}},

      {{{{0x61, 0xb0, 0xc5, 0x7e, 0xc8, 0x6a, 0xf9, 0xd4, 0x83, 0x91, 0xb3, 0x2a, 0x6e, 0x14, 0x65, 0xdc,
          0x5c, 0x2,  0xdb, 0x1,  0x1f, 0xfc, 0x6,  0xca, 0x38, 0xcb, 0xe7, 0xc0, 0x20, 0x22, 0x99, 0x9}}},
       {{0xf5, 0xee, 0x48, 0xe9, 0x3a, 0x7e, 0xe7, 0xcd, 0x99, 0x8c, 0x9e, 0xe5, 0xf1, 0xe9, 0xe1, 0xf9,
         0xa4, 0x18, 0x26, 0x2,  0xf5, 0xf7, 0x61, 0xa6, 0x83, 0xcc, 0x7f, 0xb3, 0xb9, 0x77, 0x7a, 0x9}}},

      {{{{0xb6, 0xf9, 0xda, 0x9d, 0xdc, 0xf2, 0xb3, 0xeb, 0xda, 0x2b, 0x6a, 0x72, 0xc7, 0xc4, 0x3,  0xaa,
          0xdd, 0x7,  0xde, 0x6,  0x4,  0x79, 0xf,  0x39, 0xb2, 0xca, 0x24, 0xa0, 0xdb, 0x42, 0x57, 0xf6}}},
       {{0x95, 0xf3, 0xc3, 0xf3, 0x67, 0xc1, 0x81, 0xaf, 0xd9, 0xa3, 0x6f, 0x30, 0x90, 0x1,  0xc0, 0x56,
         0xc,  0x5e, 0x5,  0x32, 0xaa, 0xa3, 0x69, 0x6b, 0x58, 0x9f, 0xd7, 0xda, 0xd5, 0xd2, 0x9e, 0x6}}},

      {{{{0x95, 0xa2, 0x41, 0x4a, 0x85, 0x47, 0xce, 0x89, 0xb1, 0xda, 0x2c, 0xf3, 0xf8, 0xb4, 0xcb, 0xa8,
          0x52, 0xcd, 0x49, 0x89, 0xd7, 0xa4, 0xc4, 0x48, 0x22, 0x6d, 0x65, 0xf6, 0xa1, 0x72, 0x42, 0x19}}},
       {{0x70, 0xdf, 0xe4, 0xb9, 0x6f, 0x53, 0x7f, 0x63, 0x74, 0x34, 0x53, 0x38, 0x75, 0xad, 0xf1, 0xc0,
         0x62, 0x0,  0x4b, 0x1e, 0x90, 0xf1, 0xbf, 0x76, 0x24, 0x8f, 0x46, 0x94, 0xd1, 0x7d, 0xdc, 0x5}}},

      {{{{0x66, 0xe,  0x6e, 0x28, 0x81, 0x66, 0x23, 0x4,  0x68, 0x10, 0x2,  0xc1, 0x85, 0xef, 0x90, 0x4f,
          0x7d, 0x3a, 0x23, 0xd3, 0xc1, 0x5f, 0x81, 0xaa, 0x1e, 0x7e, 0x21, 0xdc, 0x55, 0x9a, 0x59, 0x75}}},
       {{0x1e, 0xd,  0x33, 0x44, 0x62, 0x46, 0x79, 0xf0, 0xe9, 0xce, 0x7,  0x67, 0x6d, 0xf4, 0x75, 0x7a,
         0xab, 0x67, 0xae, 0x22, 0x4c, 0xa4, 0xf6, 0xe1, 0x8e, 0xd1, 0x25, 0x91, 0x5d, 0xc2, 0x5e, 0x3}}},
  }};

  for (const auto& oracle : Oracle) {
    const auto& input = oracle.first;
    const auto& expected = oracle.second;
    auto returnVariant = key_fast_hash_to_scalar(input.front());
    Rct::Key inplaceVariant;
    key_fast_hash_to_scalar_inplace(input.front(), inplaceVariant);
    EXPECT_EQ(returnVariant, expected);
    EXPECT_EQ(inplaceVariant, expected);
  }
}

TEST(XI_TESTSUITE, FastHashToPoint) {
  using namespace ::testing;
  using namespace ::Xi;
  using namespace ::Xi::Rct;

  std::vector<std::pair<KeyVector, Rct::Key>> Oracle{{
      {{{{0x6d, 0x6,  0x69, 0xb3, 0x67, 0x2b, 0x89, 0x7c, 0x82, 0x79, 0x79, 0xe4, 0x97, 0xf,  0x55, 0x75,
          0x22, 0xef, 0xa9, 0xb7, 0x59, 0x1d, 0xb9, 0x53, 0xe4, 0x69, 0xc2, 0xcd, 0x43, 0xdb, 0xd3, 0x53}}},
       {{0x23, 0x4e, 0x9d, 0xbe, 0x64, 0x96, 0x7,  0x24, 0x86, 0xab, 0x95, 0xdd, 0xe,  0x63, 0x8c, 0x57,
         0xf7, 0x53, 0x67, 0x35, 0xcc, 0xf3, 0x34, 0xd4, 0x5a, 0x56, 0xc6, 0x76, 0x76, 0x70, 0xfb, 0x40}}},

      {{{{0x81, 0x45, 0x26, 0x4e, 0x1a, 0x38, 0x7c, 0x96, 0xbc, 0x7f, 0xc0, 0x40, 0xd4, 0xdd, 0xe7, 0xad,
          0x65, 0x10, 0x4c, 0x10, 0x20, 0x3,  0xe3, 0x83, 0xaa, 0x60, 0x78, 0xf6, 0xa9, 0x26, 0xf6, 0x4}}},
       {{0xf1, 0x35, 0x2d, 0xc4, 0x1c, 0xb4, 0x4b, 0x87, 0x82, 0x2d, 0xe2, 0xca, 0xf1, 0x6a, 0x77, 0x6c,
         0x51, 0x34, 0xf2, 0x35, 0xf3, 0xa4, 0x5d, 0x43, 0xe,  0x48, 0x4f, 0xa0, 0xd5, 0x4c, 0x37, 0x46}}},

      {{{{0x2e, 0x10, 0x48, 0xc, 0xbe, 0xf5, 0xe1, 0xc7, 0xb0, 0x79, 0xae, 0x60, 0x70, 0x6a, 0x2b, 0x82,
          0xb1, 0x79, 0x5,  0x2, 0x37, 0x5b, 0x29, 0x5b, 0xd6, 0xe6, 0x72, 0xa8, 0xaa, 0x2,  0xd1, 0x6d}}},
       {{0xb1, 0x79, 0x87, 0xc3, 0xb1, 0xb3, 0xad, 0x1c, 0xed, 0x87, 0xbe, 0x87, 0xae, 0x8c, 0x43, 0x31,
         0x71, 0xb1, 0x88, 0xd5, 0x2a, 0x92, 0x7e, 0xff, 0x8,  0xc2, 0x7b, 0xf0, 0x7e, 0xfc, 0xdb, 0x82}}},

      {{{{0x84, 0x51, 0xd,  0xd6, 0xf7, 0xb1, 0xa5, 0x16, 0x39, 0x9c, 0xc3, 0x95, 0x4f, 0xf3, 0x80, 0x93,
          0x11, 0xe4, 0xac, 0x4e, 0xdc, 0xb0, 0xcd, 0x89, 0x9b, 0xad, 0x7e, 0x78, 0xdc, 0xe2, 0xfa, 0xea}}},
       {{0x86, 0x90, 0x8e, 0x5a, 0x20, 0x32, 0x21, 0x10, 0x61, 0x32, 0x68, 0xc0, 0x53, 0x8b, 0x80, 0x4f,
         0x5b, 0x1d, 0xbf, 0x2e, 0x46, 0x7d, 0x5e, 0xa5, 0xd6, 0xd,  0x25, 0x55, 0x18, 0x7c, 0x8d, 0xb0}}},

      {{{{0x21, 0xaa, 0x77, 0xe4, 0xab, 0x4a, 0x90, 0x5c, 0x9c, 0x88, 0xad, 0x7b, 0xd0, 0x13, 0x58, 0x47,
          0x22, 0x81, 0xde, 0xa9, 0x26, 0xd8, 0xe4, 0x74, 0x1b, 0xd2, 0x13, 0x3c, 0x24, 0x33, 0x99, 0x9e}}},
       {{0x0,  0x40, 0x6f, 0x23, 0x1e, 0xa5, 0xeb, 0x4d, 0xf1, 0xf,  0xff, 0xfd, 0x25, 0xb6, 0x98, 0xbb,
         0xa0, 0xc5, 0x43, 0xc9, 0x87, 0x72, 0x5b, 0xc2, 0x8b, 0x99, 0xe6, 0x4e, 0x8c, 0xba, 0x60, 0xb5}}},

      {{{{0x89, 0x33, 0x9a, 0xdc, 0x6e, 0xe2, 0xe3, 0x6c, 0xfe, 0x85, 0xe2, 0xfc, 0x36, 0x74, 0x15, 0xf0,
          0xb5, 0xb8, 0xd2, 0x9d, 0x8f, 0x26, 0x6f, 0xd7, 0xa8, 0xe9, 0x7b, 0x3,  0x70, 0x35, 0x14, 0xbd}}},
       {{0xd3, 0xe1, 0xb4, 0x6b, 0xec, 0x8c, 0xde, 0x8c, 0x3b, 0x8f, 0x12, 0xcc, 0x76, 0xc6, 0x3,  0x30,
         0x62, 0x39, 0xd4, 0xfa, 0xdf, 0x14, 0xee, 0x54, 0x0,  0xd,  0x9,  0xa4, 0x29, 0x7f, 0x7f, 0xc4}}},
  }};

  for (const auto& oracle : Oracle) {
    const auto& input = oracle.first;
    const auto& expected = oracle.second;
    auto returnVariant = key_fast_hash_to_point(input.front());
    Rct::Key inplaceVariant;
    key_fast_hash_to_point_inplace(input.front(), inplaceVariant);
    EXPECT_EQ(returnVariant, expected);
    EXPECT_EQ(inplaceVariant, expected);
  }
}
